Subject: Re: [PATCH] mv643xx_eth: fix SMI bus access timeouts

From: Roland Dreier <[email-masked]>
Date: Fri, 31 Oct 2008 22:47:47 -0700

> If wait_event_timeout() would return zero, mv643xx_eth would conclude
 > that the SMI access timed out, but this is not necessarily true --
 > wait_event_timeout() can also return zero in the case where the SMI
 > completion interrupt did happen in time but where it took longer than
 > the requested timeout for the process performing the SMI access to be
 > scheduled again.  This would lead to occasional SMI access timeouts
 > when the system would be under heavy load.

Would it make more sense to fix this in the wait_event_timeout() code
itself a la bb10ed09 ("sched: fix wait_for_completion_timeout() spurious
failure under heavy load")?

 - R.